/*
	file automatically generated by make_test_files.pl
	Fri Jun 14 15:21:47 2002
*/

/*****************************************************************************
 *                                                                           *
 *          UNURAN -- Universal Non-Uniform Random number generator          *
 *                                                                           *
 *****************************************************************************/
    
/**
 ** Tests for TIMING
 **/
    
/*---------------------------------------------------------------------------*/
#include "testunuran.h"
/*---------------------------------------------------------------------------*/
#ifdef T_TIMING
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* global variables                                                          */

static struct prng *urng;           /* uniform random number generator       */

static FILE *TESTLOG;               /* test log file                         */
static FILE *UNURANLOG;             /* unuran log file                       */

static int test_ok = TRUE;          /* all tests ok (boolean)                */
static int n_tests_failed;          /* number of failed tests                */

/*---------------------------------------------------------------------------*/

void test_new( void );
void test_set( void );
void test_get( void );
void test_chg( void );
void test_init( void );
void test_reinit( void );
void test_sample( void );
void test_validate( void );

void run_verify_generator( FILE *LOG, int line, UNUR_PAR *par );

int unur_timing_set_verify( UNUR_PAR *par, int );

/*---------------------------------------------------------------------------*/


static int COMPARE_SAMPLE_SIZE = 500;
static int VIOLATE_SAMPLE_SIZE = 20;

/* prototypes */





/*---------------------------------------------------------------------------*/

int main()
{ 
	/* open log file for unuran and set output stream for unuran messages */
	UNURANLOG = fopen( "t_timing_dsrou_unuran.log","w" );
	abort_if_NULL( stderr,-1, UNURANLOG );
	unur_set_stream( UNURANLOG );

	/* open log file for testing */
	TESTLOG = fopen( "t_timing_dsrou_test.log","w" );
	abort_if_NULL( stderr,-1, TESTLOG );

	/* write header into log file */
  	{
		time_t started;  
		fprintf(TESTLOG,"\nUNURAN - Universal Non-Uniform RANdom number generator\n\n");
		if (time( &started ) != -1)
			fprintf(TESTLOG,"%s",ctime(&started));
		fprintf(TESTLOG,"\n====================================================\n\n");
	}

	/* set uniform random number generator */
	urng = prng_new("mt19937(34301)");
	unur_set_default_urng(urng);

	/* set default debugging flag */
	unur_set_default_debug(UNUR_DEBUG_ALL);

	/* start test */
	printf("timing: ");

	/* run tests */
	test_new();
	test_set();
	test_get();
	test_chg();
	test_init();
	test_sample();
	test_reinit();
	test_validate();

	/* test finished */
	printf("\n");  fflush(stdout);

	/* close log files */
	fprintf(TESTLOG,"\n====================================================\n\n");
	if (test_ok)
		fprintf(TESTLOG,"All tests PASSED.\n");
	else
		fprintf(TESTLOG,"Test(s) FAILED.\n");

	fclose(UNURANLOG);
	fclose(TESTLOG);

	/* exit */
	exit( (test_ok) ? 0 : -1 );

} /* end of main */

/*---------------------------------------------------------------------------*/

void test_new (void)
{
	/* start test */
	printf("[new "); fflush(stdout);
	fprintf(TESTLOG,"\n[new]\n");

	/* reset counter */
	n_tests_failed = 0;
  

	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf("--> failed] ") : printf("--> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = new  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_new() */

/*---------------------------------------------------------------------------*/

void test_set (void)
{
	/* start test */
	printf("[set "); fflush(stdout);
	fprintf(TESTLOG,"\n[set]\n");

	/* reset counter */
	n_tests_failed = 0;
  

	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf("--> failed] ") : printf("--> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = set  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_set() */

/*---------------------------------------------------------------------------*/

void test_get (void)
{
	/* start test */
	printf("[get "); fflush(stdout);
	fprintf(TESTLOG,"\n[get]\n");

	/* reset counter */
	n_tests_failed = 0;
  

	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf("--> failed] ") : printf("--> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = get  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_get() */

/*---------------------------------------------------------------------------*/

void test_chg (void)
{
	/* start test */
	printf("[chg "); fflush(stdout);
	fprintf(TESTLOG,"\n[chg]\n");

	/* reset counter */
	n_tests_failed = 0;
  

	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf("--> failed] ") : printf("--> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = chg  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_chg() */

/*---------------------------------------------------------------------------*/

void test_init (void)
{
	/* start test */
	printf("[init "); fflush(stdout);
	fprintf(TESTLOG,"\n[init]\n");

	/* reset counter */
	n_tests_failed = 0;
  

	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf("--> failed] ") : printf("--> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = init  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_init() */

/*---------------------------------------------------------------------------*/

void test_reinit (void)
{
	/* start test */
	printf("[reinit "); fflush(stdout);
	fprintf(TESTLOG,"\n[reinit]\n");

	/* reset counter */
	n_tests_failed = 0;
  

	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf("--> failed] ") : printf("--> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = reinit  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_reinit() */

/*---------------------------------------------------------------------------*/

void test_sample (void)
{
	/* start test */
	printf("[sample "); fflush(stdout);
	fprintf(TESTLOG,"\n[sample]\n");

	/* reset counter */
	n_tests_failed = 0;
  

	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf("--> failed] ") : printf("--> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = sample  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_sample() */

/*---------------------------------------------------------------------------*/

void test_validate (void)
{
	UNUR_DISTR *distr[15];
	UNUR_PAR *par;
	UNUR_GEN *gen;
	int n_tests_failed = 0;
	double *darray;
	double fpm[10];

	/* start test */
	printf("[validate "); fflush(stdout);
	fprintf(TESTLOG,"\n[validate]\n");

	/* reset counter */
	n_tests_failed = 0;


/* distributions: 15 */
fpm[0] = 0.5;
distr[0] = unur_distr_geometric(fpm,1);


fpm[0] = 0.1;
distr[1] = unur_distr_geometric(fpm,1);


fpm[0] = 0.001;
distr[2] = unur_distr_geometric(fpm,1);


fpm[0] = 0.1;
distr[3] = unur_distr_logarithmic(fpm,1);


fpm[0] = 0.9;
distr[4] = unur_distr_logarithmic(fpm,1);


fpm[0] = 0.5;
fpm[1] = 10.;
distr[5] = unur_distr_negativebinomial(fpm,2);


fpm[0] = 0.7;
fpm[1] = 5.;
distr[6] = unur_distr_negativebinomial(fpm,2);


fpm[0] = 0.1;
fpm[1] = 20.;
distr[7] = unur_distr_negativebinomial(fpm,2);


fpm[0] = 3.;
distr[8] = unur_distr_poisson(fpm,1);


fpm[0] = 50.;
distr[9] = unur_distr_poisson(fpm,1);


fpm[0] = 10.;
fpm[1] = 0.63;
distr[10] = unur_distr_binomial(fpm,2);


fpm[0] = 20.;
fpm[1] = 0.8;
distr[11] = unur_distr_binomial(fpm,2);


fpm[0] = 2000.;
fpm[1] = 0.0013;
distr[12] = unur_distr_binomial(fpm,2);


fpm[0] = 2000.;
fpm[1] = 200.;
fpm[2] = 20;
distr[13] = unur_distr_hypergeometric(fpm,3);


fpm[0] = 2000.;
fpm[1] = 200.;
fpm[2] = 220;
distr[14] = unur_distr_hypergeometric(fpm,3);


	printf("\n(timing) "); fflush(stdout);

/* timing tests: 30 */

	unur_set_default_debug(0u);
{
	double time_setup, time_sample;
	double timing_result_setup[2];
	double timing_result_marginal[2];
	int i;

	fprintf( TESTLOG,"\nTimings (setup / marginal generation times in micro seconds):\n");
	for (i=0; i<2; i++)
		fprintf( TESTLOG, "  [    %1d    ]  ", i);
	fprintf( TESTLOG,"\n");
/* distribution [0] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[0]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[0]), distr[0] );
par = unur_dsrou_new(distr[0]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[0], timing_result_setup, timing_result_marginal, 2 );

/* distribution [0] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[0]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[0]), distr[0] );
par = unur_dsrou_new(distr[0]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[0], timing_result_setup, timing_result_marginal, 2 );

/* distribution [1] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[1]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[1]), distr[1] );
par = unur_dsrou_new(distr[1]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[1], timing_result_setup, timing_result_marginal, 2 );

/* distribution [2] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[2]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[2]), distr[2] );
par = unur_dsrou_new(distr[2]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[2], timing_result_setup, timing_result_marginal, 2 );

/* distribution [3] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[3]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[3]), distr[3] );
par = unur_dsrou_new(distr[3]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[3], timing_result_setup, timing_result_marginal, 2 );

/* distribution [4] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[4]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[4]), distr[4] );
par = unur_dsrou_new(distr[4]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[4], timing_result_setup, timing_result_marginal, 2 );

/* distribution [5] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[5]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[5]), distr[5] );
par = unur_dsrou_new(distr[5]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[5], timing_result_setup, timing_result_marginal, 2 );

/* distribution [6] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[6]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[6]), distr[6] );
par = unur_dsrou_new(distr[6]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[6], timing_result_setup, timing_result_marginal, 2 );

/* distribution [7] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[7]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[7]), distr[7] );
par = unur_dsrou_new(distr[7]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[7], timing_result_setup, timing_result_marginal, 2 );

/* distribution [8] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[8]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[8]), distr[8] );
par = unur_dsrou_new(distr[8]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[8], timing_result_setup, timing_result_marginal, 2 );

/* distribution [9] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[9]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[9]), distr[9] );
par = unur_dsrou_new(distr[9]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[9], timing_result_setup, timing_result_marginal, 2 );

/* distribution [10] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[10]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[10]), distr[10] );
par = unur_dsrou_new(distr[10]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[10], timing_result_setup, timing_result_marginal, 2 );

/* distribution [11] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[11]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[11]), distr[11] );
par = unur_dsrou_new(distr[11]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[11], timing_result_setup, timing_result_marginal, 2 );

/* distribution [12] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[12]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[12]), distr[12] );
par = unur_dsrou_new(distr[12]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[12], timing_result_setup, timing_result_marginal, 2 );

/* distribution [13] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[13]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[13]), distr[13] );
par = unur_dsrou_new(distr[13]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[13], timing_result_setup, timing_result_marginal, 2 );

/* distribution [14] */

	for (i=0; i<2; i++) timing_result_setup[i] = -1.;
	for (i=0; i<2; i++) timing_result_marginal[i] = -1.;
	unur_errno = 0;
par = unur_dsrou_new(distr[14]);
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[0] = time_setup;
	if (gen) timing_result_marginal[0] = time_sample;
	unur_free(gen);

	unur_errno = 0;
{ double Fmode = unur_distr_discr_eval_cdf( unur_distr_discr_get_mode(distr[14]), distr[14] );
par = unur_dsrou_new(distr[14]);
unur_dsrou_set_cdfatmode(par,Fmode); }
	gen = unur_test_timing(par,5,&time_setup,&time_sample,0,TESTLOG);
	if (gen) timing_result_setup[1] = time_setup;
	if (gen) timing_result_marginal[1] = time_sample;
	unur_free(gen);

	print_timing_results( TESTLOG, 0, distr[14], timing_result_setup, timing_result_marginal, 2 );

}

/* free distributions */
	unur_distr_free(distr[0]);
	unur_distr_free(distr[1]);
	unur_distr_free(distr[2]);
	unur_distr_free(distr[3]);
	unur_distr_free(distr[4]);
	unur_distr_free(distr[5]);
	unur_distr_free(distr[6]);
	unur_distr_free(distr[7]);
	unur_distr_free(distr[8]);
	unur_distr_free(distr[9]);
	unur_distr_free(distr[10]);
	unur_distr_free(distr[11]);
	unur_distr_free(distr[12]);
	unur_distr_free(distr[13]);
	unur_distr_free(distr[14]);
#if WITH_DMALLOC
	dmalloc_vmessage("section = validate  ================================\n","");
	dmalloc_log_unfreed();
#endif


	/* test finished */
	if (n_tests_failed>0) n_tests_failed--;  /* we accept one failure */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf(" --> failed] ") : printf(" --> ok] ");

} /* end of test_validate */

/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/* run generator in verifying mode */

void run_verify_generator( FILE *LOG, int line, UNUR_PAR *par )
{
	UNUR_GEN *gen;
	int i;

	/* switch to verifying mode */
	unur_timing_set_verify(par,1);

	/* initialize generator */
	gen = unur_init( par ); abort_if_NULL(LOG, line, gen);

	/* run generator */
	for (i=0; i<VIOLATE_SAMPLE_SIZE; i++)
		unur_sample_cont(gen);

	/* destroy generator */
	unur_free(gen); 

} /* end of run_verify_generator() */

int unur_timing_set_verify(UNUR_PAR *par, int verify) {return 0;}
/*---------------------------------------------------------------------------*/
#else
/*---------------------------------------------------------------------------*/
int main() { exit(77); } /* ignore test */
/*---------------------------------------------------------------------------*/
#endif  /* T_TIMING */
/*---------------------------------------------------------------------------*/
